Package ghidra.app.util.bin.format.macho.commands.codesignature

# Class CodeSignatureCodeDirectory

java.lang.Object
ghidra.app.util.bin.format.macho.commands.codesignature.CodeSignatureGenericBlob
ghidra.app.util.bin.format.macho.commands.codesignature.CodeSignatureCodeDirectory

All Implemented Interfaces:
  `StructConverter`

public class CodeSignatureCodeDirectory extends CodeSignatureGenericBlob
Represents a CS_BlobIndex structure

See Also:
  - osfmk/kern/cs_blobs.h

- ## Field Summary

  ### Fields inherited from class ghidra.app.util.bin.format.macho.commands.codesignature.CodeSignatureGenericBlob

  `base, length, magic`

  ### Fields inherited from interface ghidra.app.util.bin.StructConverter

  `ASCII, BYTE, DWORD, IBO32, IBO64, POINTER, QWORD, SLEB128, STRING, ULEB128, UTF16, UTF8, VOID, WORD`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CodeSignatureCodeDirectory(BinaryReader reader)`
  Creates a new `CodeSignatureCodeDirectory`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `markup(Program program, Address addr, MachHeader header, TaskMonitor monitor, MessageLog log)`
  Marks up this `CodeSignatureGenericBlob` data with data structures and comments
  `DataType`
  `toDataType()`
  Returns a structure datatype representing the contents of the implementor of this interface.

  ### Methods inherited from class ghidra.app.util.bin.format.macho.commands.codesignature.CodeSignatureGenericBlob

  `getLength, getMagic`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### CodeSignatureCodeDirectory

    public CodeSignatureCodeDirectory(BinaryReader reader) throws IOException
    Creates a new `CodeSignatureCodeDirectory`
    Parameters:
      `reader` - A `BinaryReader` positioned at the start of the structure
    Throws:
      `IOException` - if there was an IO-related problem creating the structure

- ## Method Details

  - ### markup

    public void markup(Program program, Address addr, MachHeader header, TaskMonitor monitor, MessageLog log) throws CancelledException
    Description copied from class: `CodeSignatureGenericBlob`
    Marks up this `CodeSignatureGenericBlob` data with data structures and comments
    Overrides:
      `markup` in class `CodeSignatureGenericBlob`
    Parameters:
      `program` - The `Program` to mark up
      `addr` - The `Address` of the blob
      `header` - The Mach-O header
      `monitor` - A cancellable task monitor
      `log` - The log
    Throws:
      `CancelledException` - if the user cancelled the operation

  - ### toDataType

    public DataType toDataType() throws DuplicateNameException, IOException
    Description copied from interface: `StructConverter`
    Returns a structure datatype representing the contents of the implementor of this interface.

    For example, given:

         class A {
             int foo;
             double bar;
         }

    The return value should be a structure data type with two data type components; an INT and a DOUBLE. The structure should contain field names and, if possible, field comments.

    Specified by:
      `toDataType` in interface `StructConverter`
    Overrides:
      `toDataType` in class `CodeSignatureGenericBlob`
    Returns:
      returns a structure datatype representing the implementor of this interface
    Throws:
      `DuplicateNameException` - when a datatype of the same name already exists
      `IOException` - if an IO-related error occurs
    See Also:
      - `StructureDataType`